<template>
    <div class="timer">
        <div class="label">Promotion Time Left:</div>
        <div class="time">
            <span class="number">{{ days }}</span>
            <div class="format">{{ wordString.day }}</div>
        </div>
        <div class="divider">:</div>
        <div class="time">
            <span class="number">{{ hours }}</span>
            <div class="format">{{ wordString.hours }}</div>
        </div>
        <div class="divider">:</div>
        <div class="time">
            <span class="number">{{ minutes }}</span>
            <div class="format">{{ wordString.minutes }}</div>
        </div>
        <div class="divider">:</div>
        <div class="time">
            <span class="number">{{ seconds }}</span>
            <div class="format">{{ wordString.seconds }}</div>
        </div>
    </div>
</template>

<script>
    export default {
        name: "Timer",
        props: ['starttime', 'endtime', 'trans'],
        data: function () {
            return {
                timer: "",
                wordString: {},
                start: "",
                end: "",
                interval: "",
                days: "",
                minutes: "",
                hours: "",
                seconds: ""
            };
        },
        created: function () {
            this.wordString = JSON.parse(this.trans);
        },
        mounted() {
            this.start = new Date(this.starttime).getTime();
            this.end = new Date(this.endtime).getTime();
            // Update the count down every 1 second
            this.timerCount(this.start, this.end);
            this.interval = setInterval(() => {
                this.timerCount(this.start, this.end);
            }, 1000);
        },
        methods: {
            timerCount: function (start, end) {
                // Get todays date and time
                var now = new Date().getTime();

                // Find the distance between now an the count down date
                var distance = start - now;
                var passTime = end - now;

                if (distance < 0 && passTime < 0) {
                    clearInterval(this.interval);
                    return;

                } else if (distance < 0 && passTime > 0) {
                    this.calcTime(passTime);

                } else if (distance > 0 && passTime > 0) {
                    this.calcTime(distance);
                }
            },
            calcTime: function (dist) {
                // Time calculations for days, hours, minutes and seconds
                this.days = Math.floor(dist / (1000 * 60 * 60 * 24));
                this.hours = Math.floor((dist % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
                this.minutes = Math.floor((dist % (1000 * 60 * 60)) / (1000 * 60));
                this.seconds = Math.floor((dist % (1000 * 60)) / 1000);
            }

        }
    }
</script>

<style scoped lang="scss">
    .timer {
        position: relative;
        left: 50%;
        transform: translateX(-50%);
        display: inline-flex;
        align-items: center;
        border-bottom: 1px dotted #ADAEB8;
        margin-top: 24px;

        .label {
            font-size: 11px;
            font-family: $secondFont, sans-serif;
            color: #ADAEB8;
            margin-right: 8px;
        }

        .divider {
            margin: 0 5px;
        }

        .time, .divider {
            display: flex;
            font-family: $secondFont, sans-serif;
            font-size: 13px;
            font-weight: 700;
            color: #4D4D65;
        }
    }
</style>
